package com.mvc.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TaskReviewPushExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TaskReviewPushExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdIsNull() {
            addCriterion("TASK_REVIEW_ID is null");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdIsNotNull() {
            addCriterion("TASK_REVIEW_ID is not null");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdEqualTo(String value) {
            addCriterion("TASK_REVIEW_ID =", value, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdNotEqualTo(String value) {
            addCriterion("TASK_REVIEW_ID <>", value, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdGreaterThan(String value) {
            addCriterion("TASK_REVIEW_ID >", value, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdGreaterThanOrEqualTo(String value) {
            addCriterion("TASK_REVIEW_ID >=", value, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdLessThan(String value) {
            addCriterion("TASK_REVIEW_ID <", value, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdLessThanOrEqualTo(String value) {
            addCriterion("TASK_REVIEW_ID <=", value, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdLike(String value) {
            addCriterion("TASK_REVIEW_ID like", value, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdNotLike(String value) {
            addCriterion("TASK_REVIEW_ID not like", value, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdIn(List<String> values) {
            addCriterion("TASK_REVIEW_ID in", values, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdNotIn(List<String> values) {
            addCriterion("TASK_REVIEW_ID not in", values, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdBetween(String value1, String value2) {
            addCriterion("TASK_REVIEW_ID between", value1, value2, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdNotBetween(String value1, String value2) {
            addCriterion("TASK_REVIEW_ID not between", value1, value2, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNull() {
            addCriterion("DEVICE_SN is null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNotNull() {
            addCriterion("DEVICE_SN is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnEqualTo(String value) {
            addCriterion("DEVICE_SN =", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotEqualTo(String value) {
            addCriterion("DEVICE_SN <>", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThan(String value) {
            addCriterion("DEVICE_SN >", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThanOrEqualTo(String value) {
            addCriterion("DEVICE_SN >=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThan(String value) {
            addCriterion("DEVICE_SN <", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThanOrEqualTo(String value) {
            addCriterion("DEVICE_SN <=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLike(String value) {
            addCriterion("DEVICE_SN like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotLike(String value) {
            addCriterion("DEVICE_SN not like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIn(List<String> values) {
            addCriterion("DEVICE_SN in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotIn(List<String> values) {
            addCriterion("DEVICE_SN not in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnBetween(String value1, String value2) {
            addCriterion("DEVICE_SN between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotBetween(String value1, String value2) {
            addCriterion("DEVICE_SN not between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andStationCodeIsNull() {
            addCriterion("STATION_CODE is null");
            return (Criteria) this;
        }

        public Criteria andStationCodeIsNotNull() {
            addCriterion("STATION_CODE is not null");
            return (Criteria) this;
        }

        public Criteria andStationCodeEqualTo(String value) {
            addCriterion("STATION_CODE =", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotEqualTo(String value) {
            addCriterion("STATION_CODE <>", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeGreaterThan(String value) {
            addCriterion("STATION_CODE >", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeGreaterThanOrEqualTo(String value) {
            addCriterion("STATION_CODE >=", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLessThan(String value) {
            addCriterion("STATION_CODE <", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLessThanOrEqualTo(String value) {
            addCriterion("STATION_CODE <=", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLike(String value) {
            addCriterion("STATION_CODE like", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotLike(String value) {
            addCriterion("STATION_CODE not like", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeIn(List<String> values) {
            addCriterion("STATION_CODE in", values, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotIn(List<String> values) {
            addCriterion("STATION_CODE not in", values, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeBetween(String value1, String value2) {
            addCriterion("STATION_CODE between", value1, value2, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotBetween(String value1, String value2) {
            addCriterion("STATION_CODE not between", value1, value2, "stationCode");
            return (Criteria) this;
        }

        public Criteria andSampleTimeIsNull() {
            addCriterion("SAMPLE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andSampleTimeIsNotNull() {
            addCriterion("SAMPLE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andSampleTimeEqualTo(Date value) {
            addCriterion("SAMPLE_TIME =", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeNotEqualTo(Date value) {
            addCriterion("SAMPLE_TIME <>", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeGreaterThan(Date value) {
            addCriterion("SAMPLE_TIME >", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("SAMPLE_TIME >=", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeLessThan(Date value) {
            addCriterion("SAMPLE_TIME <", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeLessThanOrEqualTo(Date value) {
            addCriterion("SAMPLE_TIME <=", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeIn(List<Date> values) {
            addCriterion("SAMPLE_TIME in", values, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeNotIn(List<Date> values) {
            addCriterion("SAMPLE_TIME not in", values, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeBetween(Date value1, Date value2) {
            addCriterion("SAMPLE_TIME between", value1, value2, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeNotBetween(Date value1, Date value2) {
            addCriterion("SAMPLE_TIME not between", value1, value2, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andReviewValueIsNull() {
            addCriterion("REVIEW_VALUE is null");
            return (Criteria) this;
        }

        public Criteria andReviewValueIsNotNull() {
            addCriterion("REVIEW_VALUE is not null");
            return (Criteria) this;
        }

        public Criteria andReviewValueEqualTo(BigDecimal value) {
            addCriterion("REVIEW_VALUE =", value, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueNotEqualTo(BigDecimal value) {
            addCriterion("REVIEW_VALUE <>", value, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueGreaterThan(BigDecimal value) {
            addCriterion("REVIEW_VALUE >", value, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("REVIEW_VALUE >=", value, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueLessThan(BigDecimal value) {
            addCriterion("REVIEW_VALUE <", value, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("REVIEW_VALUE <=", value, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueIn(List<BigDecimal> values) {
            addCriterion("REVIEW_VALUE in", values, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueNotIn(List<BigDecimal> values) {
            addCriterion("REVIEW_VALUE not in", values, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("REVIEW_VALUE between", value1, value2, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("REVIEW_VALUE not between", value1, value2, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagIsNull() {
            addCriterion("FINISHED_FLAG is null");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagIsNotNull() {
            addCriterion("FINISHED_FLAG is not null");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagEqualTo(String value) {
            addCriterion("FINISHED_FLAG =", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagNotEqualTo(String value) {
            addCriterion("FINISHED_FLAG <>", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagGreaterThan(String value) {
            addCriterion("FINISHED_FLAG >", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagGreaterThanOrEqualTo(String value) {
            addCriterion("FINISHED_FLAG >=", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagLessThan(String value) {
            addCriterion("FINISHED_FLAG <", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagLessThanOrEqualTo(String value) {
            addCriterion("FINISHED_FLAG <=", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagLike(String value) {
            addCriterion("FINISHED_FLAG like", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagNotLike(String value) {
            addCriterion("FINISHED_FLAG not like", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagIn(List<String> values) {
            addCriterion("FINISHED_FLAG in", values, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagNotIn(List<String> values) {
            addCriterion("FINISHED_FLAG not in", values, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagBetween(String value1, String value2) {
            addCriterion("FINISHED_FLAG between", value1, value2, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagNotBetween(String value1, String value2) {
            addCriterion("FINISHED_FLAG not between", value1, value2, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeIsNull() {
            addCriterion("FINISHED_TIME is null");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeIsNotNull() {
            addCriterion("FINISHED_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeEqualTo(Date value) {
            addCriterion("FINISHED_TIME =", value, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeNotEqualTo(Date value) {
            addCriterion("FINISHED_TIME <>", value, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeGreaterThan(Date value) {
            addCriterion("FINISHED_TIME >", value, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("FINISHED_TIME >=", value, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeLessThan(Date value) {
            addCriterion("FINISHED_TIME <", value, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeLessThanOrEqualTo(Date value) {
            addCriterion("FINISHED_TIME <=", value, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeIn(List<Date> values) {
            addCriterion("FINISHED_TIME in", values, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeNotIn(List<Date> values) {
            addCriterion("FINISHED_TIME not in", values, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeBetween(Date value1, Date value2) {
            addCriterion("FINISHED_TIME between", value1, value2, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeNotBetween(Date value1, Date value2) {
            addCriterion("FINISHED_TIME not between", value1, value2, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andPushNumIsNull() {
            addCriterion("PUSH_NUM is null");
            return (Criteria) this;
        }

        public Criteria andPushNumIsNotNull() {
            addCriterion("PUSH_NUM is not null");
            return (Criteria) this;
        }

        public Criteria andPushNumEqualTo(Integer value) {
            addCriterion("PUSH_NUM =", value, "pushNum");
            return (Criteria) this;
        }

        public Criteria andPushNumNotEqualTo(Integer value) {
            addCriterion("PUSH_NUM <>", value, "pushNum");
            return (Criteria) this;
        }

        public Criteria andPushNumGreaterThan(Integer value) {
            addCriterion("PUSH_NUM >", value, "pushNum");
            return (Criteria) this;
        }

        public Criteria andPushNumGreaterThanOrEqualTo(Integer value) {
            addCriterion("PUSH_NUM >=", value, "pushNum");
            return (Criteria) this;
        }

        public Criteria andPushNumLessThan(Integer value) {
            addCriterion("PUSH_NUM <", value, "pushNum");
            return (Criteria) this;
        }

        public Criteria andPushNumLessThanOrEqualTo(Integer value) {
            addCriterion("PUSH_NUM <=", value, "pushNum");
            return (Criteria) this;
        }

        public Criteria andPushNumIn(List<Integer> values) {
            addCriterion("PUSH_NUM in", values, "pushNum");
            return (Criteria) this;
        }

        public Criteria andPushNumNotIn(List<Integer> values) {
            addCriterion("PUSH_NUM not in", values, "pushNum");
            return (Criteria) this;
        }

        public Criteria andPushNumBetween(Integer value1, Integer value2) {
            addCriterion("PUSH_NUM between", value1, value2, "pushNum");
            return (Criteria) this;
        }

        public Criteria andPushNumNotBetween(Integer value1, Integer value2) {
            addCriterion("PUSH_NUM not between", value1, value2, "pushNum");
            return (Criteria) this;
        }

        public Criteria andPushRawMsgIsNull() {
            addCriterion("PUSH_RAW_MSG is null");
            return (Criteria) this;
        }

        public Criteria andPushRawMsgIsNotNull() {
            addCriterion("PUSH_RAW_MSG is not null");
            return (Criteria) this;
        }

        public Criteria andPushRawMsgEqualTo(String value) {
            addCriterion("PUSH_RAW_MSG =", value, "pushRawMsg");
            return (Criteria) this;
        }

        public Criteria andPushRawMsgNotEqualTo(String value) {
            addCriterion("PUSH_RAW_MSG <>", value, "pushRawMsg");
            return (Criteria) this;
        }

        public Criteria andPushRawMsgGreaterThan(String value) {
            addCriterion("PUSH_RAW_MSG >", value, "pushRawMsg");
            return (Criteria) this;
        }

        public Criteria andPushRawMsgGreaterThanOrEqualTo(String value) {
            addCriterion("PUSH_RAW_MSG >=", value, "pushRawMsg");
            return (Criteria) this;
        }

        public Criteria andPushRawMsgLessThan(String value) {
            addCriterion("PUSH_RAW_MSG <", value, "pushRawMsg");
            return (Criteria) this;
        }

        public Criteria andPushRawMsgLessThanOrEqualTo(String value) {
            addCriterion("PUSH_RAW_MSG <=", value, "pushRawMsg");
            return (Criteria) this;
        }

        public Criteria andPushRawMsgLike(String value) {
            addCriterion("PUSH_RAW_MSG like", value, "pushRawMsg");
            return (Criteria) this;
        }

        public Criteria andPushRawMsgNotLike(String value) {
            addCriterion("PUSH_RAW_MSG not like", value, "pushRawMsg");
            return (Criteria) this;
        }

        public Criteria andPushRawMsgIn(List<String> values) {
            addCriterion("PUSH_RAW_MSG in", values, "pushRawMsg");
            return (Criteria) this;
        }

        public Criteria andPushRawMsgNotIn(List<String> values) {
            addCriterion("PUSH_RAW_MSG not in", values, "pushRawMsg");
            return (Criteria) this;
        }

        public Criteria andPushRawMsgBetween(String value1, String value2) {
            addCriterion("PUSH_RAW_MSG between", value1, value2, "pushRawMsg");
            return (Criteria) this;
        }

        public Criteria andPushRawMsgNotBetween(String value1, String value2) {
            addCriterion("PUSH_RAW_MSG not between", value1, value2, "pushRawMsg");
            return (Criteria) this;
        }

        public Criteria andReplyMsgIsNull() {
            addCriterion("REPLY_MSG is null");
            return (Criteria) this;
        }

        public Criteria andReplyMsgIsNotNull() {
            addCriterion("REPLY_MSG is not null");
            return (Criteria) this;
        }

        public Criteria andReplyMsgEqualTo(String value) {
            addCriterion("REPLY_MSG =", value, "replyMsg");
            return (Criteria) this;
        }

        public Criteria andReplyMsgNotEqualTo(String value) {
            addCriterion("REPLY_MSG <>", value, "replyMsg");
            return (Criteria) this;
        }

        public Criteria andReplyMsgGreaterThan(String value) {
            addCriterion("REPLY_MSG >", value, "replyMsg");
            return (Criteria) this;
        }

        public Criteria andReplyMsgGreaterThanOrEqualTo(String value) {
            addCriterion("REPLY_MSG >=", value, "replyMsg");
            return (Criteria) this;
        }

        public Criteria andReplyMsgLessThan(String value) {
            addCriterion("REPLY_MSG <", value, "replyMsg");
            return (Criteria) this;
        }

        public Criteria andReplyMsgLessThanOrEqualTo(String value) {
            addCriterion("REPLY_MSG <=", value, "replyMsg");
            return (Criteria) this;
        }

        public Criteria andReplyMsgLike(String value) {
            addCriterion("REPLY_MSG like", value, "replyMsg");
            return (Criteria) this;
        }

        public Criteria andReplyMsgNotLike(String value) {
            addCriterion("REPLY_MSG not like", value, "replyMsg");
            return (Criteria) this;
        }

        public Criteria andReplyMsgIn(List<String> values) {
            addCriterion("REPLY_MSG in", values, "replyMsg");
            return (Criteria) this;
        }

        public Criteria andReplyMsgNotIn(List<String> values) {
            addCriterion("REPLY_MSG not in", values, "replyMsg");
            return (Criteria) this;
        }

        public Criteria andReplyMsgBetween(String value1, String value2) {
            addCriterion("REPLY_MSG between", value1, value2, "replyMsg");
            return (Criteria) this;
        }

        public Criteria andReplyMsgNotBetween(String value1, String value2) {
            addCriterion("REPLY_MSG not between", value1, value2, "replyMsg");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}